Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFileSet.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFileSet.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSFileSet.java	(revision 5945)
@@ -8,8 +8,14 @@
 import java.util.Map;
 import java.util.HashMap;
+import java.util.List;
+import java.util.ArrayList;
 import java.util.Iterator;
 
 import java.io.File;
 import java.io.PrintWriter;
+
+import java.sql.SQLException;
+import java.sql.ResultSet;
+
 import java.net.URL;
 
@@ -20,11 +26,20 @@
 
 public class METSFileSet
-{ Map fileGroups;
+{ Map    fileGroups;
+  String reference;
 
   public METSFileSet()
   { this.fileGroups = new HashMap();
     this.fileGroups.put("default", new METSFileGroup("default"));
-  }
-
+    this.reference = null;
+  }
+  
+  /**
+   *  Get the group that corresponds to the given name...
+   *
+   *  @param <code>String</code> the name of the group.
+   *  @return <code>METSFileGroup</code> the group object - this will be
+   *          <code>null</code> if the group is not found
+   */
   public METSFileGroup getGroup(String name)
   { if (!this.fileGroups.containsKey(name))
@@ -34,4 +49,10 @@
   }
 
+  /**
+   *  Get the Nth file from the default group...
+   *
+   *  @param <code>int</code> the index into the default group to use...
+   *  @return <code>METSFile</code> the file.
+   */
   public METSFile getFile(int index)
   { METSFileGroup group = this.getGroup("default");
@@ -70,6 +91,30 @@
   }
 
+  /**
+   *  Add a group at the top level of the METS File set.
+   *
+   *  @param <code>METSFileGroup</code> the file group to add.
+   */
   public void addGroup(METSFileGroup group)
   { this.fileGroups.put(group.getName(), group);
+  }
+
+  /**
+   *  Get all the groups that contain a given URL/file.
+   *
+   *  @param <code>URL</code> the location of the file.
+   *  @return <code>List</code> the list of group references that contain the file.
+   */
+  public List findGroups(URL file)
+  { List resultList = new ArrayList();
+
+    Iterator groups = this.fileGroups.values().iterator();
+
+    while (groups.hasNext())
+    { METSFileGroup group = (METSFileGroup) groups.next();
+      
+      group.findGroups(file, resultList);
+    }
+    return resultList;
   }
 
@@ -86,18 +131,109 @@
   }
 
-  public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
+  public boolean writeSQL(DocumentInterface document, GS3SQLConnection connection)
   { Iterator groups = this.fileGroups.values().iterator();
 
-    GS3SQLInsert insert = new GS3SQLInsert("filesection");
-    insert.addValue("DocID", document.getID().toString());
-    insert.addValue("FileSecID", "test"); // TODO: remove magic string
-
-    connection.execute(insert.toString());
+    // write the set if the reference does not already exist...
+    if (this.reference == null)
+    { // Insert the file section into the database
+      GS3SQLInsert insert = new GS3SQLInsert("filesection");
+      insert.addValue("DocID", document.getID().toString());
+      insert.addValue("FileSecID", "test"); // TODO: remove magic string
+
+      if (!connection.execute(insert.toString()))
+      { return false;
+      }
+
+      // find the file section number
+      GS3SQLSelect select = new GS3SQLSelect("filesection");
+      select.addField("*");
+      GS3SQLWhereItem whereItem = new GS3SQLWhereItem("FileSecID", "=", "test");
+      GS3SQLWhereItem whereDoc  = new GS3SQLWhereItem("DocID", "=", document.getID().toString());
+      GS3SQLWhere where = new GS3SQLWhere(whereItem);
+      where.add(whereDoc);
+      select.setWhere(where);
+
+      try {
+	connection.execute(select.toString());
+	
+	ResultSet set = connection.getResultSet();
+	set.first();
+	int sectionRef = set.getInt("FileSectionRef");
+
+	this.reference = Integer.toString(sectionRef);
+      }
+      catch (SQLException ex)
+      { System.out.println(ex);
+        return false;
+      }
+    }
     
+    // write out the children
     while (groups.hasNext())
     { METSFileGroup group = (METSFileGroup) groups.next();
-
-      group.writeSQL(document, connection);
-    }
-  }
+      
+      if (!group.writeSQL(document, this.reference, true, connection))
+      { return false;
+      }
+    }
+
+    return true;
+  }
+
+  public static METSFileSet readSQL(DocumentInterface document, GS3SQLConnection connection)
+  { 
+    METSFileSet set = new METSFileSet();    
+
+    // Get file sections from the filesection table (currently redundant)
+    GS3SQLSelect select = new GS3SQLSelect("filesection");
+    select.addField("*");
+    GS3SQLWhereItem whereItem = new GS3SQLWhereItem("DocID", "=", document.getID().toString());
+    select.setWhere(new GS3SQLWhere(whereItem));
+    connection.execute(select.toString());
+    
+    // Get the identifier for this file set, etc.
+    ResultSet sections = connection.getResultSet();
+    int fileSetRef;
+    try {
+      sections.first();
+      fileSetRef     = sections.getInt("FileSectionRef");
+      set.reference = Integer.toString(fileSetRef);
+    }
+    catch (SQLException ex)
+    { System.out.println(ex);
+      return null;
+    }
+    
+    // Get child file groups
+    select = new GS3SQLSelect("filegroups");
+    select.addField("*");
+    whereItem = new GS3SQLWhereItem("DocID", "=", document.getID().toString());    
+    GS3SQLWhere where = new GS3SQLWhere(whereItem);
+    whereItem = new GS3SQLWhereItem("ParentRef", "=", Integer.toString(fileSetRef), 
+				    GS3SQLField.INTEGER_TYPE);
+    where.add(whereItem);
+    whereItem = new GS3SQLWhereItem("ParentType", "=", METSFileGroup.SECTION_PARENT);
+    where.add(whereItem);
+    select.setWhere(where);
+    connection.execute(select.toString());
+
+    // start going through the matching file groups
+    try {
+      ResultSet resultSet = connection.getResultSet();
+      resultSet.first();
+      do {
+	METSFileGroup filegroup = METSFileGroup.readSQL(document, connection, resultSet);
+	if (filegroup != null) {
+	  set.addGroup(filegroup);
+	}
+      } while (resultSet.next());
+    }
+    catch (SQLException sqlEx) {
+      System.out.println(sqlEx);
+      System.exit(1);
+    }
+
+    return set;
+  }
+
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSLocation.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSLocation.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSLocation.java	(revision 5945)
@@ -6,28 +6,32 @@
 public class METSLocation
 {
-	String type;
-	URL    location;
+  String type;
+  URL    location;
 
-	public METSLocation(String type, String location) throws java.net.MalformedURLException
-	{	this.type = type;
-	 	this.location = new URL(location);
-	}
+  public METSLocation(String type, String location) throws java.net.MalformedURLException
+  { this.type = type;
+    this.location = new URL(location);
+  }
 
-	public METSLocation(URL url)
-	{	this.type = "URL";
-		this.location = url;
-	}
+  public METSLocation(URL url)
+  { this.type = "URL";
+    this.location = url;
+  }
 
-	public METSLocation(File file) throws java.net.MalformedURLException
-	{ this.type = "URL";
-		this.location = new URL("file://" + file.toString());
-	}
+  public METSLocation(File file) throws java.net.MalformedURLException
+  { this.type = "URL";
+    this.location = new URL("file://" + file.toString());
+  }
 
-	public URL getLocation()
-	{	return this.location;
-	}
+  public boolean equals(URL url)
+  { return this.location.equals(url);
+  }
 
-	public String getType()
-	{	return this.type;
-	}
+  public URL getLocation()
+  { return this.location;
+  }
+
+  public String getType()
+  { return this.type;
+  }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSNamespace.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSNamespace.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSNamespace.java	(revision 5945)
@@ -4,4 +4,7 @@
 
 import java.util.List;
+
+import java.sql.SQLException;
+import java.sql.ResultSet;
 
 import org.greenstone.gsdl3.gs3build.util.GS3SQLConnection;
@@ -36,48 +39,48 @@
   }
 
-	/**
-	 *  Get the name of the namespace...
-	 *
-	 *  @return <code>String</code> the name of the namespace
-	 */
-	public String getName()
-	{	return this.name;
-	}
-
-	/**
-	 *  Get the group of namespaces to which this namespace belongs.
-	 *
-	 *  @return <code>String</code> the name of the namespace group
-	 */
-	public String getGroup()
-	{	return this.group;
-	}
+  /**
+   *  Get the name of the namespace...
+   *
+   *  @return <code>String</code> the name of the namespace
+   */
+  public String getName()
+  { return this.name;
+  }
+
+  /**
+   *  Get the group of namespaces to which this namespace belongs.
+   *
+   *  @return <code>String</code> the name of the namespace group
+   */
+  public String getGroup()
+  { return this.group;
+  }
 	
-	/**
-	 *  Set the group of namespaces to which this namespace belongs.
-	 *
-	 *  @param <code>String</code> the name of the namespace group
-	 */
-	public void setGroup(String group)
-	{	this.group = group;
-	}
-
-	/**
-	 *  Get the ID for this namespace.
-	 *
-	 *  @return <code>String</code> the id of the namespace
-	 */
-	public String getID()
-	{ return this.id;
-	}
-
-	/**
-	 *  Set the id of this namespace.
-	 *
-	 *  @param <code>String</code> the name of the namespace group
-	 */
-	public void setID(String id)
-	{	this.id = id;
-	}
+  /**
+   *  Set the group of namespaces to which this namespace belongs.
+   *
+   *  @param <code>String</code> the name of the namespace group
+   */
+  public void setGroup(String group)
+  { this.group = group;
+  }
+
+  /**
+   *  Get the ID for this namespace.
+   *
+   *  @return <code>String</code> the id of the namespace
+   */
+  public String getID()
+  { return this.id;
+  }
+
+  /**
+   *  Set the id of this namespace.
+   *
+   *  @param <code>String</code> the name of the namespace group
+   */
+  public void setID(String id)
+  { this.id = id;
+  }
 
   /**
@@ -107,24 +110,108 @@
   public boolean writeSQL(int parentId, GS3SQLConnection connection)
   { 
-    GS3SQLInsert insert = new GS3SQLInsert("namespaces");
-
+    GS3SQLAction action;
+
+    // If the namespace is not null, then set it...
     if (this.id != null) {
-	insert.addValue("NamespaceID", this.id);
+      // use an update action in this case...
+      GS3SQLUpdate update = new GS3SQLUpdate("namespaces");
+      update.addValue("NamespaceID", this.id);
+
+      // set up the where clause
+      GS3SQLWhere where = 
+	new GS3SQLWhere(new GS3SQLWhereItem("NamespaceRef", "=", this.id, 
+					    GS3SQLField.INTEGER_TYPE));
+      update.setWhere(where);
+      action = update;
+    }
+    else {
+      GS3SQLInsert insert = new GS3SQLInsert("namespaces");
+      action = insert;
     }
 
     if (this.location != null) {
-      insert.addValue("fileLoc", this.location.getLocation().toString());
-      insert.addValue("fileType", "URL");
+      action.addValue("fileLoc", this.location.getLocation().toString());
+      action.addValue("fileType", "URL");
     }
     else {
       // no location stuff
     }
-    insert.addValue("MetadataRef", Integer.toString(parentId), GS3SQLField.INTEGER_TYPE);
-    insert.addValue("NamespaceType", this.name);
-
-    //    System.out.println(insert.toString());
-    connection.execute(insert.toString());
+    action.addValue("MetadataRef", Integer.toString(parentId), GS3SQLField.INTEGER_TYPE);
+    action.addValue("NamespaceType", this.name);
+
+    // Execute the action
+    connection.execute(action.toString());
+
+    // then get the namespace reference number if needsbe...
+    if (this.id == null) {
+      GS3SQLSelect select = new GS3SQLSelect("namespaces");
+      select.addField("NamespaceRef");
+      GS3SQLWhereItem whereItem = new GS3SQLWhereItem("MetadataRef", "=", Integer.toString(parentId), GS3SQLField.INTEGER_TYPE);
+      GS3SQLWhere where = new GS3SQLWhere(whereItem);
+      whereItem = new GS3SQLWhereItem("NamespaceType", "=", this.name);
+      where.add(where);
+      try {
+	connection.execute(select.toString());
+      
+	ResultSet result = connection.getResultSet();
+	result.last();
+	this.id = Integer.toString(result.getInt("NamespaceRef"));
+      }
+      catch (SQLException sqlex)
+      { this.id = null;
+        System.err.println(sqlex);
+	return false;
+      }
+    }
 
     return true;
   }
+
+  public static METSNamespace readSQL(GS3SQLConnection connection, ResultSet resultSet)
+  {
+    METSLocation metsLocation = null;
+    
+    try {
+      String name = resultSet.getString("NamespaceType");
+      String id = resultSet.getString("NamespaceRef");
+      String location = resultSet.getString("fileLoc");
+      String type = resultSet.getString("fileType");
+      if (location != null && type != null) {
+	metsLocation = new METSLocation(type, location);
+      }
+
+      METSNamespace namespace = NamespaceFactory.initNamespace(name, metsLocation);
+      namespace.id = id;
+
+      int namespaceRef = resultSet.getInt("NamespaceRef");
+      
+      GS3SQLSelect select = new GS3SQLSelect("mdvalues");
+      select.addField("*");
+      GS3SQLWhere where = new GS3SQLWhere(new GS3SQLWhereItem("NamespaceRef", "=", Integer.toString(namespaceRef),
+							      GS3SQLField.INTEGER_TYPE));
+      select.setWhere(where);
+
+      connection.execute(select.toString());
+      
+      ResultSet valuesSet = connection.getResultSet();
+      if (valuesSet != null && valuesSet.first()) {
+	do {
+	  String label = valuesSet.getString("label");
+	  String value = valuesSet.getString("value");
+
+	  namespace.addMetadata(label, value);
+	}
+	while (valuesSet.next());
+      }
+
+      return namespace;
+    }
+    catch (java.net.MalformedURLException urlEx)
+    { System.out.println(urlEx);
+    }
+    catch (SQLException sqlEx)
+    { System.out.println(sqlEx);
+    }    
+    return null;
+  }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSStructure.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSStructure.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSStructure.java	(revision 5945)
@@ -10,4 +10,5 @@
 
 import java.sql.SQLException;
+import java.sql.ResultSet;
 
 import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;
@@ -19,112 +20,245 @@
 public class METSStructure
 {
-	Map children;
-	String ID;
-	String label;
-	String type;
-
-	public METSStructure(String id, String label, String type)
-	{	this.children = new HashMap();
-		this.ID       = id;
-		this.label    = label;
-		this.type     = type;
-	}
-
-	public String getID()
-	{	return this.ID;
-	}
-
-	public void addDivision(METSDivision division)
-	{	this.children.put(division.getID(), division);
-	}
-
-	public void addSubDivision(String divisionID, METSDivision division)
-	{	String topDivision = METSDivision.getTopDivisionName(divisionID);
-
-		METSDivision child = (METSDivision) this.children.get(topDivision);
-		if (child == null)
-		{	return;
-		}
-
-		String subDivisionID = METSDivision.getSubDivisionName(divisionID);
-		if (subDivisionID == null)
-		{ child.addSubDivision(division);
-		}
-		else
-		{	child.addSubDivision(subDivisionID, division);
-		}
-	}
-
-	public METSDivision getDivision(String divisionID)
-	{	String topDivision = METSDivision.getTopDivisionName(divisionID);
-
-		METSDivision child = (METSDivision) this.children.get(topDivision);
-		if (child == null)
-		{	return null;
-		}
-
-		String subDivision = METSDivision.getSubDivisionName(divisionID);
-		if (subDivision != null)
-		{	child = child.getDivision(subDivision);
-		}
-
-		return child;
-	}
-
-	public void write(PrintWriter writer)
-	{ Iterator groups = this.children.values().iterator();
-
-		String tag = XMLTools.getOpenTag("mets", "structMap");
-		tag = XMLTools.addAttribute(tag, "ID", this.ID.toString());
-		tag = XMLTools.addAttribute(tag, "TYPE", this.type.toString());
-		tag = XMLTools.addAttribute(tag, "LABEL", this.label.toString());
+  Map children;
+  String ID;
+  String label;
+  String type;
+  
+  public METSStructure(String id, String label, String type)
+  { this.children = new HashMap();
+    this.ID       = id;
+    this.label    = label;
+    this.type     = type;
+  }
+  
+  /**
+   *  Get the identifer of this structure
+   *
+   *  @param <code>String</code> the identifier.
+   */
+  public String getID()
+  { return this.ID;
+  }
+
+  /**
+   *  Find all the divisions that match a given list of file group
+   *  identifiers...
+   *
+   *  @param <code>List</code> the list of identifiers to find
+   *  @param <code>List</code> the list into which to place any
+   *         matching identifiers.
+   */
+  public void findDivisionsForFiles(List listOfFileIdentifiers, List resultList)
+  { Iterator groups = this.children.values().iterator();
+    while (groups.hasNext())
+    { METSDivision group = (METSDivision) groups.next();
+
+      group.findDivisionsForFiles(listOfFileIdentifiers, resultList);
+    }    
+  }
+
+  /**
+   *  Add a division directly underneath this structure.
+   *
+   *  @param <code>METSDivision</code> the division to add.
+   */
+  public void addDivision(METSDivision division)
+  { this.children.put(division.getID(), division);
+  }
+
+  /**
+   *  Add a division further into this structure.
+   *
+   *  @param <code>String</code> the identifier for the division
+   *         within which the division is to be added.
+   *  @param <code>METSDivision</code> the division to add.   
+   */
+  public void addSubDivision(String divisionID, METSDivision division)
+  { String topDivision = METSDivision.getTopDivisionName(divisionID);
+
+    METSDivision child = (METSDivision) this.children.get(topDivision);
+    if (child == null)
+    { return;
+    }
+
+    String subDivisionID = METSDivision.getSubDivisionName(divisionID);
+    if (subDivisionID == null)
+    { child.addSubDivision(division);
+    }
+    else
+    { child.addSubDivision(subDivisionID, division);
+    }
+  }
+
+  /**
+   *  Get a subdivision of a given identifier...
+   * 
+   *  @param <code>String</code> the identifier of the division
+   *  @return <code>METSDivision</code> the division, which will be
+   *          <code>null</code> if it is not found.
+   */
+  public METSDivision getDivision(String divisionID)
+  { String topDivision = METSDivision.getTopDivisionName(divisionID);
+
+    METSDivision child = (METSDivision) this.children.get(topDivision);
+    if (child == null)
+    { return null;
+    }
+
+    String subDivision = METSDivision.getSubDivisionName(divisionID);
+    if (subDivision != null)
+    { child = child.getDivision(subDivision);
+    }
+
+    return child;
+  }
+
+  public void write(PrintWriter writer)
+  { Iterator groups = this.children.values().iterator();
+
+    String tag = XMLTools.getOpenTag("mets", "structMap");
+    tag = XMLTools.addAttribute(tag, "ID", this.ID.toString());
+    tag = XMLTools.addAttribute(tag, "TYPE", this.type);
+    tag = XMLTools.addAttribute(tag, "LABEL", this.label);
 		
-		writer.println(tag);
-		while (groups.hasNext())
-		{	METSDivision group = (METSDivision) groups.next();
-
-			group.write(writer);
-		}
-		writer.println("</mets:structMap>");
-	}
-
-
-    public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
-    { Iterator groups = this.children.values().iterator();
-
+    writer.println(tag);
+    while (groups.hasNext())
+    { METSDivision group = (METSDivision) groups.next();
+
+      group.write(writer);
+    }
+    writer.println("</mets:structMap>");
+  }
+
+
+  /**
+   *  Write this METSStructure to an SQL database....
+   *
+   *  @param <code>DocumentInterface</code> the enclosing document.
+   *  @param <code>GS3SQLConnection</code> the SQL database connection.
+   */
+  public boolean writeSQL(DocumentInterface document, GS3SQLConnection connection)
+  { int sqlRef = -1;
+    ResultSet results;
+
+    // Prepare query to see if this structure has already been written
+    GS3SQLSelect select = new GS3SQLSelect("structure");
+    select.addField("StructureRef");
+    GS3SQLWhereItem whereItem = new GS3SQLWhereItem("DocID", "=", document.getID().toString());
+    GS3SQLWhereItem item = new GS3SQLWhereItem("StructureID", "=", this.ID.toString());
+    GS3SQLWhere where = new GS3SQLWhere(whereItem);
+    where.add(item);
+    select.setWhere(where);
+
+    // attempt to execute the query & get the current structure's reference
+    try {
+      connection.execute(select.toString());
+      results = connection.getResultSet();
+      if (results != null &&
+	  results.first())
+      { sqlRef = results.getInt("structureRef");
+      }
+      else 
+      { results = null;
+      }
+    }
+    catch (SQLException sqlEx) {
+      System.err.print(sqlEx);
+      return false;
+    }
+
+    // insert a new structure if it wasn't there previously
+    if (results == null) {
       GS3SQLInsert insert = new GS3SQLInsert("structure");
       insert.addValue("DocID", document.getID().toString());
       insert.addValue("StructureID", this.ID.toString());
-      insert.addValue("Type", this.type.toString());
-      insert.addValue("Label", this.label.toString());
+      insert.addValue("Type", this.type);
+      insert.addValue("Label", this.label);
       
-      System.out.println(insert.toString());
-      connection.execute(insert.toString());
+      if (!connection.execute(insert.toString())) {
+	return false;
+      }
+
+      // get the new structure reference by re-running the original select object
+      connection.execute(select.toString());
+
+      try {
+	results = connection.getResultSet();
+	results.first();
+	sqlRef = results.getInt("StructureRef");
+      }
+      catch (SQLException sql) {
+	System.err.println(sql);
+	return false;
+      }
+    }
+    else {
+      GS3SQLUpdate update = new GS3SQLUpdate("structure");
+      update.setWhere(where);
+
+      update.addValue("Type", this.type);
+      update.addValue("Label", this.label);
+
+      connection.execute(update.toString());
+    }
       
-      // get the new structure reference
-      GS3SQLSelect select = new GS3SQLSelect("structure");
-      select.addField("StructureRef");
-      GS3SQLWhereItem whereItem = new GS3SQLWhereItem("StructureID", "=", this.ID);
-      GS3SQLWhereItem item = new GS3SQLWhereItem("DocID", "=", document.getID().toString());
+    // write out the child groups (Divisions) now...    
+    Iterator groups = this.children.values().iterator();
+
+    while (groups.hasNext())
+    { METSDivision group = (METSDivision) groups.next();
+
+      if (!group.writeSQL(sqlRef, true, connection))
+      { return false;
+      }
+    }
+    return true;
+  }
+
+
+  public static METSStructure readSQL(DocumentInterface document, GS3SQLConnection connection,
+				      ResultSet resultSet)
+  {
+    try {
+      String ID    = resultSet.getString("StructureID");
+      String type  = resultSet.getString("Type");
+      String label = resultSet.getString("Label");
+
+      // create the metadata block object
+      METSStructure structure = new METSStructure(ID, label, type);
+      
+      // get its metadata reference to retrieve divisions
+      int structureRef = resultSet.getInt("StructureRef");
+
+      // query the database for matching division for this structure block
+      GS3SQLSelect select = new GS3SQLSelect("divisions");
+      select.addField("*");
+      GS3SQLWhereItem whereItem = new GS3SQLWhereItem("ParentRef", "=", Integer.toString(structureRef),
+						      GS3SQLField.INTEGER_TYPE);
       GS3SQLWhere where = new GS3SQLWhere(whereItem);
-      where.add(item);
+      whereItem = new GS3SQLWhereItem("ParentType", "=", METSDivision.STRUCTURE_PARENT);
+      where.add(whereItem);
       select.setWhere(where);
-      System.out.println(select.toString());
+
       connection.execute(select.toString());
 
-      try {
-        // read in the structure reference
-        connection.getResultSet().first();
-	int sqlRef = connection.getResultSet().getInt("StructureRef");
-        
-	while (groups.hasNext())
-	{ METSDivision group = (METSDivision) groups.next();
-
-          group.writeSQL(sqlRef, true, connection);
+      // parse through the divisions
+      ResultSet divisionSet = connection.getResultSet();
+      divisionSet.first();
+      do {
+	METSDivision division = METSDivision.readSQL(connection, divisionSet);
+	if (division != null) {
+	  structure.addDivision(division);
 	}
       }
-      catch (SQLException sql) {
-	  System.out.println(sql);
-      }
-    }
+      while (divisionSet.next());
+
+      return structure;
+    }
+    catch (SQLException sqlEx)
+    { System.out.println(sqlEx);
+      System.exit(1);
+    }
+    return null;
+  }
 }
Index: /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSStructureSet.java
===================================================================
--- /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSStructureSet.java	(revision 5944)
+++ /trunk/gsdl3/src/java/org/greenstone/gsdl3/gs3build/metadata/METSStructureSet.java	(revision 5945)
@@ -5,69 +5,141 @@
 import java.util.HashMap;
 import java.util.Map;
+import java.util.List;
+import java.util.ArrayList;
 import java.util.Iterator;
+
+import java.sql.SQLException;
+import java.sql.ResultSet;
 
 import org.greenstone.gsdl3.gs3build.doctypes.DocumentInterface;
 
 import org.greenstone.gsdl3.gs3build.util.GS3SQLConnection;
+import org.greenstone.gsdl3.gs3build.database.*;
 
 public class METSStructureSet
-{	Map children;
+{ Map children;
 
-	public METSStructureSet()
-	{	this.children = new HashMap();
-	}
+  public METSStructureSet()
+  { this.children = new HashMap();
+  }
 
-	public void addStructure(METSStructure structure)
-	{	this.children.put(structure.getID(), structure);
-	}
+  public void addStructure(METSStructure structure)
+  { this.children.put(structure.getID(), structure);
+  }
 
-	public METSStructure getStructure(String name)
-	{	return (METSStructure) this.children.get(name);
-	}
+  public METSStructure getStructure(String name)
+  { return (METSStructure) this.children.get(name);
+  }
 
-	public void addDivision(String structureName, METSDivision division)
-	{	METSStructure structure = (METSStructure) this.children.get(structureName);
+  /**
+   *  Find the divisions that contain a list of given files
+   *
+   *  @param <code>List</code> the list of files to find...
+   *  @return <code>List</code> the matching divisions.
+   */
+  public List findDivisionsForFiles(List listOfFileIdentifiers)
+  { List reply = new ArrayList();
 
-		if (structure != null)
-		{ structure.addDivision(division);
-		}
-	}
+    // iterate across all the children...
+    Iterator structures = this.children.values().iterator();
+    
+    while (structures.hasNext())
+    { METSStructure structure = (METSStructure) structures.next();
 
-	public void addSubDivision(String structureName, String divisionID, METSDivision division)
-	{	METSStructure structure = (METSStructure) this.children.get(structureName);
+      structure.findDivisionsForFiles(listOfFileIdentifiers, reply);      
+    }    
+    return reply;
+  }
 
-		if (structure != null)
-		{ structure.addSubDivision(divisionID, division);
-		}
-	}
+  /**
+   *  Add a division to an indicated structure.
+   *
+   *  @param <code>String</code> the structure identifier
+   *  @param <code>METSDivision</code> the division to be added.
+   */
+  public void addDivision(String structureName, METSDivision division)
+  { METSStructure structure = (METSStructure) this.children.get(structureName);
 
-	public METSDivision getDivision(String structureName, String divisionID)
-	{	METSStructure structure = (METSStructure) this.children.get(structureName);
-
-		if (structure != null)
-		{ return structure.getDivision(divisionID);
-		}
-		return null;
-	}
-
-	public void write(PrintWriter writer)
-	{ Iterator groups = this.children.values().iterator();
-
-		while (groups.hasNext())
-		{	METSStructure group = (METSStructure) groups.next();
-
-			group.write(writer);
-		}
-	}
-
-  public void writeSQL(DocumentInterface document, GS3SQLConnection connection)
-  { Iterator groups = this.children.values().iterator();
-    
-    while (groups.hasNext())
-    { METSStructure group = (METSStructure) groups.next();
-
-      group.writeSQL(document, connection);
+    if (structure != null)
+    { structure.addDivision(division);
     }
   }
 
+  /**
+   *  Add a division to an indicated division within structure.
+   *
+   *  @param <code>String</code> the structure identifier
+   *  @param <code>String</code> the division identifer, within which the division
+   *         is to be placed.
+   *  @param <code>METSDivision</code> the division to be added.
+   */
+  public void addSubDivision(String structureName, String divisionID, METSDivision division)
+  { METSStructure structure = (METSStructure) this.children.get(structureName);
+
+    if (structure != null)
+    { structure.addSubDivision(divisionID, division);
+    }
+  }
+
+  public METSDivision getDivision(String structureName, String divisionID)
+  { METSStructure structure = (METSStructure) this.children.get(structureName);
+
+    if (structure != null)
+    { return structure.getDivision(divisionID);
+    }
+    return null;
+  }
+
+  public void write(PrintWriter writer)
+  { Iterator structures = this.children.values().iterator();
+
+    while (structures.hasNext())
+    { METSStructure group = (METSStructure) structures.next();
+
+      group.write(writer);
+    }
+  }
+
+  public boolean writeSQL(DocumentInterface document, GS3SQLConnection connection)
+  { Iterator structures = this.children.values().iterator();
+    
+    while (structures.hasNext())
+    { METSStructure group = (METSStructure) structures.next();
+
+      if (!group.writeSQL(document, connection))
+      { return false;
+      }
+    }
+    return true;
+  }
+
+  public static METSStructureSet readSQL(DocumentInterface document, GS3SQLConnection connection)
+  { 
+    METSStructureSet set = new METSStructureSet();
+
+    GS3SQLSelect select = new GS3SQLSelect("structure");
+    select.addField("*");
+    GS3SQLWhereItem whereItem = new GS3SQLWhereItem("DocID", "=", document.getID().toString());
+    select.setWhere(new GS3SQLWhere(whereItem));
+    connection.execute(select.toString());
+
+    // start going through the matching metadata blocks
+    try {
+      ResultSet resultSet = connection.getResultSet();
+      resultSet.first();
+      do {
+	METSStructure structure = METSStructure.readSQL(document, connection, resultSet);
+	if (structure != null) {
+	  set.addStructure(structure);
+	}
+      } while (resultSet.next());
+    }
+    catch (SQLException sqlEx) {
+      System.out.println(sqlEx);
+      System.exit(1);
+    }
+
+    return set;
+  }
+
 }
